﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using C1.WPF.FlexGrid;

namespace Wpf_Flex_CellstyleOnCell
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("CurrencyCode", typeof(int));
            dt.Columns.Add("Industry", typeof(string));
            dt.Columns.Add("Market", typeof(string));
            dt.Columns.Add("Sector", typeof(int));
            dt.Columns.Add("Total", typeof(double));
            dt.Columns.Add("SecurityType", typeof(string));
            dt.Rows.Add(1, "Ind1", "M1", 100, null, "type1");
            dt.Rows.Add(2, "Ind2", "M2", 200, null, "type2");
            dt.Rows.Add(3, "Ind3", "M3", 300, 12345678.1234567, "type3");
            dt.Rows.Add(4, "Ind4", "M4", 400, 12345678.1234567, "type4");
            dt.Rows.Add(5, "Ind5", "M5", 500, 12345678.1234567, "type5");
            dt.Rows.Add(6, "Ind6", "M6", 600, 12345678.1234567, "type6");
            dt.Rows.Add(7, "Ind7", "M7", 700, 12345678.1234567, "type7");
            dt.Rows.Add(8, "Ind8", "M8", 800, 12345678.1234567, "type8");
            dt.Rows.Add(9, "Ind9", "M9", 900, 12345678.1234567, "type9");

            flex.CellFactory = new MyCellFactory();
            flex.ItemsSource = dt.AsDataView();

        }


    }

    public class MyCellFactory : CellFactory
    {
        public void resetFont(TextBlock _textblock)
        {
            _textblock.FontSize = 12;
            _textblock.FontWeight = FontWeights.Bold;
            _textblock.FontStyle = FontStyles.Italic;
        }

        public override void ApplyCellStyles(C1FlexGrid grid, CellType cellType, CellRange range, Border bdr)
        {
           var columnindex = range.Column;
            var rowindex = range.Row;
            var _textblock = bdr.Child as TextBlock;
            if (_textblock == null) return;
            //check if the cell is selected or not
            bool selected=(columnindex == grid.Selection.Column && rowindex == grid.Selection.Row);
            if ((columnindex == 2) && (rowindex == 3))
            {
                if (selected)
                {
                    _textblock.FontSize = 12d;
                    _textblock.FontWeight = FontWeights.Normal;
                    _textblock.FontStyle = FontStyles.Normal;                    
                }
                else
                {
                    bdr.Background = new SolidColorBrush(Colors.Red);
                    _textblock.Foreground = Brushes.Yellow;
                    _textblock.FontSize = 14d;
                    _textblock.FontWeight = FontWeights.Bold;
                    _textblock.FontStyle = FontStyles.Italic;
                }
                grid.Invalidate(new CellRange(3, 2));
            }
        
        }
     
    }
}
